#pragma once

#include	"Preference.h"

class CPageColor :
	public CPropertyPageImpl<CPageColor>
{
public:
    enum { IDD = IDD_COLOR };

public:
	CPreference	*m_pPrefs;
private:
	CEdit	m_edtvollow;
	CEdit	m_edtvolhigh;
	CEdit	m_edtbg;
	CEdit	m_edtfrmlt;
	CEdit	m_edtfrmbr;
	CEdit	m_edtmute;

public:

    // RXgN^
    CPageColor( ATL::_U_STRINGorID title = (LPCTSTR)NULL  )
        : CPropertyPageImpl<CPageColor>(title)
    {
	}

	virtual ~CPageColor(void)
	{}
	
BEGIN_MSG_MAP_EX(CPageColor)
    MSG_WM_INITDIALOG(OnInitDialog)
    CHAIN_MSG_MAP(CPropertyPageImpl<CPageColor>)
END_MSG_MAP()

    LRESULT OnInitDialog(HWND /*hWnd*/, LPARAM /*lParam*/)
	{
		TCHAR buff[256];

#define	INITITEM( e , id ) { e = GetDlgItem(id); }
#define	SET_HEX( e , n ) { _stprintf( buff ,_T("%08X") , n ); e.SetWindowText(buff);	}
		
		INITITEM( m_edtvollow	,IDC_EDIT_VOL_LOW);
		INITITEM( m_edtvolhigh 	,IDC_EDIT_VOL_HIGH);
		INITITEM( m_edtbg 		,IDC_EDIT_BG);
		INITITEM( m_edtfrmlt 	,IDC_EDIT_FRAME_TOPLEFT);
		INITITEM( m_edtfrmbr 	,IDC_EDIT_FRAME_BOTTOMRIGHT);
		INITITEM( m_edtmute 		,IDC_EDIT_MUTE);

		SET_HEX( m_edtvollow	,m_pPrefs->m_Color1	);
		SET_HEX( m_edtvolhigh 	,m_pPrefs->m_Color2	);
		SET_HEX( m_edtbg 	,m_pPrefs->m_ColorBG 	);
		SET_HEX( m_edtfrmlt 	,m_pPrefs->m_ColorFrame1);
		SET_HEX( m_edtfrmbr 	,m_pPrefs->m_ColorFrame2);
		SET_HEX( m_edtmute 	,m_pPrefs->m_ColorMute 	);
		
#undef	INITITEM
#undef	SET_HEX
         return TRUE;
    }

    BOOL OnKillActive(){
		TCHAR buff[256];
		TCHAR *p;

#define	GET_HEX( e , n ) { 	e.GetWindowText(buff,10); n = _tcstoul(buff,&p,16); }
		GET_HEX( m_edtvollow	,m_pPrefs->m_Color1		);
		GET_HEX( m_edtvolhigh 	,m_pPrefs->m_Color2		);
		GET_HEX( m_edtbg 	,m_pPrefs->m_ColorBG 		);
		GET_HEX( m_edtfrmlt 	,m_pPrefs->m_ColorFrame1 	);
		GET_HEX( m_edtfrmbr 	,m_pPrefs->m_ColorFrame2 	);
		GET_HEX( m_edtmute 	,m_pPrefs->m_ColorMute 		);
#undef	GET_HEX
        return TRUE;
    }

};
