#pragma once

#include "IVolumeControl.h"

class CStatus
{
	IVolumeControl *m_volctrl;
public:
	CStatus(){
		m_wndTooltip = NULL;
		m_volctrl = NULL;
	}
	virtual ~CStatus(void){
	}

	void SetVolCtrl(IVolumeControl *volctrl)
	{
		m_volctrl = volctrl;
	}
private:
	bool	m_Vertical;
	//int		m_Volume;
	//bool	m_Mute;
	int		m_RectLeft;
	int		m_RectRight;
	HWND	m_wndTooltip;

	void UpdateTootlTip(){
		if ( IsWindow(m_wndTooltip) ){
			SendMessage( m_wndTooltip , TTM_UPDATE , 0,0 );
		}
	}
public:
	void	SetVertical(bool val){	m_Vertical = val; }
	bool	GetVertical(){	return m_Vertical ; }

	void	SetVolume(int val){	m_volctrl->SetVolume(val); UpdateTootlTip(); }
	int		GetVolume(){ return m_volctrl->GetVolume();	}

	void	SetMute(bool val){	m_volctrl->SetMute(val); UpdateTootlTip(); }
	bool	GetMute(){	return m_volctrl->GetMute(); }

	void	SetBarPos( int low , int high ){ m_RectLeft = low; m_RectRight = high; }
	int		GetPosLow(){ return m_RectLeft ; }
	int		GetPosHigh(){ return m_RectRight ; }

	void	SetTooltip( HWND hwnd ){	m_wndTooltip = hwnd; }
};
