#pragma once

struct IVolumeControlCallback abstract{
	virtual void onVolumeChanged( int vol , bool mute )=0;
};

class IVolumeControl 
{
public:
	enum	DeviceRole {	drConsole , drComm , drMM };

	virtual void	SetVolume( int volume )=0;
	virtual int		GetVolume()=0;
	virtual void	SetMute( bool mute )=0;
	virtual bool	GetMute()=0;
};

extern IVolumeControl *VolumeControlFactory( IVolumeControl::DeviceRole role , IVolumeControlCallback *cb=NULL );

