#pragma once

#include "commonversion.h"

class CPageAbout :
	public CPropertyPageImpl<CPageAbout>
{
public:
    enum { IDD = IDD_ABOUT };
	CPreference	*m_pPrefs;
    CHyperLink m_link;     // nCp[N
	CStatic	   m_ver;
public:

    // RXgN^
    CPageAbout(ATL::_U_STRINGorID title = (LPCTSTR)NULL)
        : CPropertyPageImpl<CPageAbout>(title)
    {}

	virtual ~CPageAbout(void)
	{}

BEGIN_MSG_MAP_EX(CPageAbout)
    MSG_WM_INITDIALOG(OnInitDialog)
	COMMAND_ID_HANDLER_EX(IDC_BUTTON_DEFAULT, OnButtonDefault)
    CHAIN_MSG_MAP(CPropertyPageImpl<CPageAbout>)
END_MSG_MAP()

    LRESULT OnInitDialog(HWND /*hWnd*/, LPARAM /*lParam*/){
        //m_button_topmost = GetDlgItem(IDC_CHECK_TOPMOST);

        //m_button_topmost.SetCheck(m_bTopmost);
		TCHAR buff[256];
		_stprintf( buff , _T("Ver %d.%d.%d.%d") , VER0, VER1, VER2, VER3 ); 

		m_ver = GetDlgItem(IDC_VERSION);
		m_ver.SetWindowText( buff );

        m_link.SubclassWindow(GetDlgItem(IDC_STATIC_LINK));
		m_link.SetLabel(_T("AhGXL http://pandora.sblo.jp"));
        m_link.SetHyperLink(_T("http://pandora.sblo.jp/article/34433147.html"));

         return TRUE;
    }

    BOOL OnKillActive(){
        //m_bTopmost = (m_button_topmost.GetCheck() != 0);

        return TRUE;
    }
    void OnButtonDefault(UINT /*uNotifyCode*/, int /*nID*/, HWND /*hWndCtl*/)
	{
		m_pPrefs->Load();		
		UINT uIcon = MB_OK| MB_ICONINFORMATION;

        MessageBox(_T("Loaded Default Settings."), _T("Volume Deskband"), uIcon);
    }


};
