#pragma once


class CPageAppearance :
	public CPropertyPageImpl<CPageAppearance>
{
public:
    enum { IDD = IDD_APPEARANCE };

	CPreference	*m_pPrefs;

private:
	CEdit	m_edtheight;
	CEdit	m_edtframe;
	CEdit	m_edtminlength;
	CComboBox	m_cmborient;
	CButton 	m_chkpopup;

public:

    // RXgN^
    CPageAppearance(ATL::_U_STRINGorID title = (LPCTSTR)NULL)
        : CPropertyPageImpl<CPageAppearance>(title)
    {}

	virtual ~CPageAppearance(void)
	{}

BEGIN_MSG_MAP_EX(CPageAppearance)
    MSG_WM_INITDIALOG(OnInitDialog)
    CHAIN_MSG_MAP(CPropertyPageImpl<CPageAppearance>)
END_MSG_MAP()

    LRESULT OnInitDialog(HWND /*hWnd*/, LPARAM /*lParam*/){
        //m_button_topmost = GetDlgItem(IDC_CHECK_TOPMOST);

        //m_button_topmost.SetCheck(m_bTopmost);

		TCHAR buff[256];

#define	INITITEM( e , id ) { e = GetDlgItem(id); }
#define	SET_INT( e,n ) {_stprintf( buff ,_T("%d") , n ); e.SetWindowText(buff);	}
#define	SET_SEL( e, n )	{	e.SetCurSel(n);  }
#define	SET_CHK( e,n ) { e.SetCheck(n);	}

		INITITEM( m_edtheight ,  IDC_HEIGHT );	
		INITITEM( m_edtframe ,   IDC_FRAME );	
		INITITEM( m_edtminlength ,  IDC_MINLENGTH );	
		INITITEM( m_cmborient , IDC_ORIENTAL );
		INITITEM( m_chkpopup , IDC_POPUP );		

		m_cmborient.AddString( _T("Left to Right") );
		m_cmborient.AddString( _T("Right to Left") );
		m_cmborient.AddString( _T("Top to Bottom") );
		m_cmborient.AddString( _T("Bottom to Top") );

		SET_INT( m_edtheight , m_pPrefs->m_Height );
		SET_INT( m_edtframe , m_pPrefs->m_Frame );
		SET_INT( m_edtminlength , m_pPrefs->m_MinLength );
		SET_SEL( m_cmborient , m_pPrefs->m_Oriental % 4);
		SET_CHK( m_chkpopup, m_pPrefs->m_Popup );
		
#undef	INITITEM
#undef	SET_INT
#undef	SET_SEL
#undef	SET_CHK

         return TRUE;
    }

    BOOL OnKillActive(){
        //m_bTopmost = (m_button_topmost.GetCheck() != 0);
		TCHAR buff[256];
#define	GET_INT( e, n )	{	e.GetWindowText(buff,10); n = _ttoi( buff ); }
#define	GET_SEL( e, n )	{	n = e.GetCurSel();  }
#define	GET_CHK( e, n )	{	n = e.GetCheck(); }

		GET_INT( m_edtheight , m_pPrefs->m_Height );
		GET_INT( m_edtframe , m_pPrefs->m_Frame );
		GET_INT( m_edtminlength , m_pPrefs->m_MinLength );
		GET_SEL( m_cmborient, m_pPrefs->m_Oriental);
		GET_CHK( m_chkpopup, m_pPrefs->m_Popup );

#undef	GET_INT
#undef	GET_SEL
#undef	GET_CHK

        return TRUE;
    }

};
