#pragma once


class CPageControl :
	public CPropertyPageImpl<CPageControl>
{
public:
    enum { IDD = IDD_CONTROL };

	CPreference	*m_pPrefs;

private:
	CEdit	m_edttick;
	CButton	m_chkignore1st;
	CButton	m_chkdoubleclick;
	CComboBox	m_cmbtarget;

public:

    // RXgN^
    CPageControl(ATL::_U_STRINGorID title = (LPCTSTR)NULL)
        : CPropertyPageImpl<CPageControl>(title)
    {}

	virtual ~CPageControl(void)
	{}

BEGIN_MSG_MAP_EX(CPageControl)
    MSG_WM_INITDIALOG(OnInitDialog)
    CHAIN_MSG_MAP(CPropertyPageImpl<CPageControl>)
END_MSG_MAP()

    LRESULT OnInitDialog(HWND /*hWnd*/, LPARAM /*lParam*/){
        //m_button_topmost = GetDlgItem(IDC_CHECK_TOPMOST);

        //m_button_topmost.SetCheck(m_bTopmost);
		TCHAR buff[256];
#define	INITITEM( e , id ) { e = GetDlgItem(id); }
#define	SET_INT( e,n ) {_stprintf( buff ,_T("%d") , n ); e.SetWindowText(buff);	}
#define	SET_SEL( e, n )	{	e.SetCurSel(n);  }
#define	SET_CHK( e,n ) { e.SetCheck(n);	}

		INITITEM( m_edttick ,  IDC_EDIT_TICK );	
		INITITEM( m_chkignore1st ,   IDC_CHECK_FIRSTCLICK );	
		INITITEM( m_chkdoubleclick ,  IDC_CHECK_DOUBLECLICK );	
		INITITEM( m_cmbtarget , IDC_COMBO_TARGET );

		m_cmbtarget.AddString( _T("Console") );
		m_cmbtarget.AddString( _T("Communication") );
		m_cmbtarget.AddString( _T("MultiMedia") );

		SET_INT( m_edttick , m_pPrefs->m_VolStep );
		SET_CHK( m_chkignore1st , m_pPrefs->m_IgnoreFirstClick );
		SET_CHK( m_chkdoubleclick , m_pPrefs->m_MuteDoubleClick );
		SET_SEL( m_cmbtarget , m_pPrefs->m_Target);
		
#undef	INITITEM
#undef	SET_INT
#undef	SET_SEL
#undef	SET_CHK

         return TRUE;
    }

    BOOL OnKillActive(){
        //m_bTopmost = (m_button_topmost.GetCheck() != 0);
		TCHAR buff[256];
#define	GET_INT( e, n )	{	e.GetWindowText(buff,10); n = _ttoi( buff ); }
#define	GET_SEL( e, n )	{	n = e.GetCurSel();  }
#define	GET_CHK( e, n )	{	n = e.GetCheck(); }

		GET_INT( m_edttick , m_pPrefs->m_VolStep );
		GET_CHK( m_chkignore1st , m_pPrefs->m_IgnoreFirstClick );
		GET_CHK( m_chkdoubleclick , m_pPrefs->m_MuteDoubleClick );
		GET_SEL( m_cmbtarget , m_pPrefs->m_Target);

#undef	GET_INT
#undef	GET_SEL
#undef	GET_CHK


        return TRUE;
    }

};
